Subject: Re: bug#17229: [PATCH 2/2] grep: speed-up by using memchr() in Boyer-Moore searching

From: Paul Eggert <[email-masked]>
Date: Thu, 10 Apr 2014 14:11:18 -0700

On 04/10/2014 04:37 AM, Norihiro Tanaka wrote:
> The patch requires below. bug#17230 [PATCH 1/2] grep: may also use 
> Boyer-Moore algorithm for case-insensitive matching

OK, thanks, I'll work on Bug #17230 first, before worrying about 17229.

> It'd be simpler to use memchr on all platforms;
> is there a major performance downside to that?
> Yes.  As far as I was confirmed, it's slow in HP-UX on Itanium and
> Solaris on SPARC.  I think that that it depends on the implementation of
> memchr() and the rate of the increment instruction for the `add'
> instruction on the platform.

If it's *way* slower with memchr and HP-UX/Itanium or Solaris/SPARC we 
may need to complicate the code, but if it's just a bit slower then it's 
probably better to use the simpler implementation. There's a tradeoff 
between simplified maintenance and performance on non-GNU hosts; 
sometimes the former is more important than the latter, and this may be 
one of those times.